Package: org.apache.groovy.groovysh.jline

## [Groovy] Class ObjectInspector

- org.apache.groovy.groovysh.jline.ObjectInspector

-     class ObjectInspector
      extends Object

  Adapts Groovy's inspector output into structures used by groovysh commands and completions.

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static String` | `FIELD_MODIFIERS` | Modifier key used in method descriptions.
    `static String` | `FIELD_NAME` | Field name key used in method and property descriptions.
    `static String` | `FIELD_PARAMETERS` | Parameter list key used in method descriptions.
    `static String` | `FIELD_RETURN` | Return type key used in method descriptions.
    `static List<String>` | `GLOBAL_META_METHODS` | Meta-method names that are treated as globally available and hidden from results.
    `static List<String>` | `METHOD_COLUMNS` | Column order used when converting inspector method rows into maps.

  - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `Object` | `inspector` Groovy inspector backing the extracted metadata.
    `Object` | `obj` Object being described.
    `Object` | `types` Type hierarchy names collected for the inspected object.

  - ### Constructor Summary

    Constructors
    Constructor and description
    `ObjectInspector(Object obj)` Creates an inspector facade for the supplied object.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `List<Map<String, String>>` | `metaMethods()` Returns meta-methods while filtering operator-style entries.
    `` | `List<Map<String, String>>` | `metaMethods(boolean includeOperatorMethods)` Returns meta-methods visible on the inspected object.
    `` | `List<Map<String, String>>` | `methods()` Returns declared methods as maps keyed by METHOD_COLUMNS.
    `` | `Object` | `properties()` Returns grouped property information from the Groovy inspector.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### public static final String FIELD_MODIFIERS

      Modifier key used in method descriptions.

    - #### public static final String FIELD_NAME

      Field name key used in method and property descriptions.

    - #### public static final String FIELD_PARAMETERS

      Parameter list key used in method descriptions.

    - #### public static final String FIELD_RETURN

      Return type key used in method descriptions.

    - #### public static final List<String> GLOBAL_META_METHODS

      Meta-method names that are treated as globally available and hidden from results.

    - #### public static final List<String> METHOD_COLUMNS

      Column order used when converting inspector method rows into maps.

  - ### Property Detail

    - #### Object inspector

      Groovy inspector backing the extracted metadata.

    - #### Object obj

      Object being described.

    - #### Object types

      Type hierarchy names collected for the inspected object.

  - ### Constructor Detail

    - #### ObjectInspector(Object obj)

      Creates an inspector facade for the supplied object.

      Parameters:
        `obj` - object to inspect

  - ### Method Detail

    - #### List<Map<String, String>> metaMethods()

      Returns meta-methods while filtering operator-style entries.

      Returns:
        filtered meta-method descriptors

    - #### List<Map<String, String>> metaMethods(boolean includeOperatorMethods)

      Returns meta-methods visible on the inspected object.

      Parameters:
        `includeOperatorMethods` - whether operator-style meta-methods should be included
      Returns:
        filtered meta-method descriptors

    - #### List<Map<String, String>> methods()

      Returns declared methods as maps keyed by METHOD_COLUMNS.

      Returns:
        method descriptors derived from the Groovy inspector

    - #### Object properties()

      Returns grouped property information from the Groovy inspector.

      Returns:
        property metadata keyed by inspector category